
#ifndef __TEXTUREX_PANEL_H__
#define __TEXTUREX_PANEL_H__

#include "TextureXList.h"
#include "TextureEditorPanel.h"
#include "VirtualListView.h"

class TextureXEditor;

class TextureXListView : public VirtualListView {
private:
	TextureXList*	texturex;

protected:
	string	getItemText(long item, long column) const;
	//void	updateItemAttr(long item) const;

public:
	TextureXListView(wxWindow* parent, TextureXList* texturex);
	~TextureXListView();

	void	updateList(bool clear = false);
};

class TextureXPanel : public wxPanel {
private:
	TextureXList		texturex;
	TextureXEditor*		tx_editor;
	ArchiveEntry*		tx_entry;
	CTexture*			tex_current;

	TextureXListView*	list_textures;
	TextureEditorPanel*	texture_editor;
	wxButton*			btn_new_texture;
	wxButton*			btn_remove_texture;
	wxButton*			btn_new_from_patch;
	wxButton*			btn_new_from_file;
	wxButton*			btn_move_up;
	wxButton*			btn_move_down;
	wxStaticText*		label_tx_format;

public:
	TextureXPanel(wxWindow* parent, TextureXEditor* tx_editor);
	~TextureXPanel();

	TextureXList&	txList() { return texturex; }
	ArchiveEntry*	txEntry() { return tx_entry; }

	bool	openTEXTUREX(ArchiveEntry* texturex);
	bool	saveTEXTUREX();
	void	setPalette(Palette8bit* pal);
	void	applyChanges();

	CTexture*	newTextureFromPatch(string name, string patch);

	// Events
	void	onTextureListSelect(wxListEvent& e);
	void	onBtnNewTexture(wxCommandEvent& e);
	void	onBtnNewTextureFromPatch(wxCommandEvent& e);
	void	onBtnNewTextureFromFile(wxCommandEvent& e);
	void	onBtnRemoveTexture(wxCommandEvent& e);
	void	onBtnMoveUp(wxCommandEvent& e);
	void	onBtnMoveDown(wxCommandEvent& e);
};

#endif//__TEXTUREX_PANEL_H__
